# How to contribute to level-model

## Prerequisites:

- Familiarity with [GitHub pull requests](https://help.github.com/articles/using-pull-requests) and issues.
- Knowledge of [markdown](https://help.github.com/articles/markdown-basics/) for editing `.md` documents.
- Understanding of JavaScript.

## Types of contributions

Here are a few of the types of contributions that we're looking for. Have an idea but it doesn't fit into this list? Make an issue for it in the issues queue of the project.

### Ideas

Participate in an issues thread or start your own to have your voice heard.

### Code

Fix issues or contribute new features to this or any related projects.

### Writing

Contribute your expertise in an area by helping us expand the text in the application, README.md file, and other content.

### Copy editing

Fix typos, clarify language, and generally improve the quality of the content.

## Steps to contributing

- Fork the repository
- Create a branch for your changes
- Make the changes you'd like to contribute. See the "types of contributions" list above to learn more about what we're looking for
- Submit a pull request

## Conduct

We are committed to providing a friendly, safe, and welcoming environment for
all, regardless of gender, sexual orientation, disability, ethnicity, religion,
or similar personal characteristic.

Be kind and courteous. There's no need to be mean or rude.
Respect that people have differences of opinion and that every design or
implementation choice carries a trade-off and numerous costs. There is seldom
a right answer, merely an optimal answer given a set of values and
circumstances.

Keep unstructured critique to a minimum. If you have solid ideas you
want to experiment with, make a fork and see how it works.

Avoid using overtly sexual nicknames or other nicknames that
might detract from a friendly, safe and welcoming environment for all.

We will exclude you from interaction if you insult, demean or harass anyone.
That is not welcome behavior. We interpret the term "harassment" as
including the definition in the
[Citizen Code of Conduct](CONDUCT.md);
if you have any lack of clarity about what might be included in that concept,
please read their definition. In particular, we don't tolerate behavior that
excludes people in socially marginalized groups.

Private harassment is also unacceptable. No matter who you are, if you feel
you have been or are being harassed or made uncomfortable by a community
member, please contact one of the channel ops or any of the core team
immediately. Whether you're a regular contributor or a newcomer, we care about
making this community a safe place for you and we've got your back.

Likewise any spamming, trolling, flaming, baiting or other attention-stealing
behavior is not welcome.


## Communication

See the [README](README.md#contact) for detailed communication and maintainer contact information.

Please follow the conduct guidelines above in all communication about this project. Language issues
are often contentious and we'd like to keep discussion brief, civil and focused
on what we're actually doing, not wandering off into too much imaginary stuff.
